//elo_usb_rcvintpipe
#include <linux/module.h>
#include <linux/slab.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/usb.h>

#include "elolib.h"





int elo_usb_control_msg(struct usb_device *dev, unsigned int pipe,
	__u8 request, __u8 requesttype, __u16 value, __u16 index,
	void *data, __u16 size, int timeout)
{

	return usb_control_msg(dev,  pipe,
	request, requesttype,  value, index,
	data,  size,  timeout);
}


#ifndef LKV_24
int elo_usb_submit_urb(struct urb *urb, int mem_flags)
{
	return usb_submit_urb(urb, mem_flags);
}


struct urb *elo_usb_alloc_urb(int iso_packets, int mem_flags)
{
	return usb_alloc_urb(iso_packets, mem_flags);
}
#else
int elo_usb_submit_urb(struct urb *urb)
{
	return usb_submit_urb(urb);
}


struct urb *elo_usb_alloc_urb(int iso_packets)
{
	return usb_alloc_urb(iso_packets);
}

#endif
//elo_usb_rcvctrlpipe

int elo_usb_unlink_urb(struct urb *urb)
{
 return usb_unlink_urb(urb);
}

#ifndef LKV_24
void * elo_usb_buffer_alloc(struct usb_device *dev, size_t size,
	int mem_flags, dma_addr_t *dma)
{
	return usb_buffer_alloc (dev,  size, mem_flags, dma);
}
#endif

int elo_printk(const char*fmt, ...)
{
	va_list args;
	char buf[81];
	int len;

	va_start(args, fmt);
	len = vsprintf(buf, fmt, args);
	va_end(args);
 	printk("%s",buf);
	return len;;
}


void elo_usb_fill_int_urb(struct urb *urb,
				     struct usb_device *dev,
				     unsigned int pipe,
				     void *transfer_buffer,
				     int buffer_length,
				     usb_complete_t complete,
				     void *context,
				     int interval)
{
	return usb_fill_int_urb (urb,dev, pipe, transfer_buffer,buffer_length,
				     complete,context,interval);
}

void * elo_kmalloc(size_t size, int priority)
{
       
	return kmalloc (size, priority);
      
}
//elo_usb_sndctrlpipe


#ifndef LKV_24
void elo_usb_set_intfdata(struct usb_interface *intf, void *data)
{
	return usb_set_intfdata (intf, data);
}

void *elo_usb_get_intfdata(struct usb_interface *intf)
{
	return usb_get_intfdata (intf);
}


void elo_usb_buffer_free(struct usb_device *dev, size_t size,
	void *addr, dma_addr_t dma)
{
	return usb_buffer_free (dev,size, addr, dma);
}
#endif

void elo_usb_deregister(struct usb_driver * driver)
{
	return usb_deregister(driver);
}

void *elo_memset(void *s, int c, size_t n)
{
  return memset(s, c,  n);
}
int elo_usb_register(struct usb_driver * driver)
{
	return usb_register(driver);
	
}

void elo_kfree(void * __ptr)
{
	return kfree (__ptr);
}

void elo_usb_free_urb(struct urb *urb)
{
	return usb_free_urb(urb);
}



